<!DOCTYPE html>
<html>
	<head>
		<title>Voucher CRUD</title>
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
		<link
			rel="stylesheet"
			href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
		/>
		<!-- Data Table-->
		<link
			rel="stylesheet"
			href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
		/>
		<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
		<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
	</head>

	<body>
		<!-- Vùng header -->
		<div class="container">
			<div class="text-center">
				<h2>Danh sách người dùng đăng kí</h2>
			</div>
			<div class="form-group">
				<button class="btn btn-success" id="btn-add-user">
					<i class="fa fa-plus"></i>&nbsp; Thêm user
				</button>
			</div>
		</div>
		<!-- Vouche Data Table -->
		<div class="container">
			<table
				class="table table-bordered table-striped table-hover"
				id="user-table"
			>
				<thead>
					<tr>
						<th>Id</th>
						<th>Firstname</th>
						<th>Lastname</th>
						<th>Country</th>
						<th>Subject</th>
						<th>Customer Type</th>
						<th>Register Status</th>
						<th>Action</th>
					</tr>
				</thead>
			</table>
		</div>
		<!-- Vùng Modal -->

		<!-- Create voucher modal -->
		<div>
			<div id="create-user-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Thêm User</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-voucher-code">First name</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-create-firstname"
											name="First name"
											placeholder="First name"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Last name</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-create-lastname"
											name="Last name"
											placeholder="Last name"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Subject</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-create-subject"
											name="Subject"
											placeholder="Subject"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Country</label>
									</div>
									<div class="col-sm-8">
										<select class="form-control" id="sel-country">
											<option value="VN">Việt Nam</option>
											<option value="USA">USA</option>
											<option value="AUS">Australia</option>
										</select>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Customer Type</label>
									</div>
									<div class="col-sm-8">
										<select class="form-control" id="sel-customertype">
											<option value="Standard">Standard</option>
											<option value="Premium">Premium</option>
											<option value="Gold">Gold</option>
										</select>
									</div>
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-success" id="btn-create-user">
								Insert User
							</button>

							<button
								class="btn btn-secondary"
								id="btn-create-cancel"
								data-dismiss="modal"
							>
								Hủy bỏ
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-user-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Chi tiết User</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-voucher-code">First name</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-update-firstname"
											name="First name"
											placeholder="First name"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Last name</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-update-lastname"
											name="Last name"
											placeholder="Last name"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Subject</label>
									</div>
									<div class="col-sm-8">
										<input
											type="text"
											id="input-update-subject"
											name="Subject"
											placeholder="Subject"
											class="form-control"
										/>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Country</label>
									</div>
									<div class="col-sm-8">
										<select class="form-control" id="sel-update-country">
											<option value="VN">Việt Nam</option>
											<option value="USA">USA</option>
											<option value="AUS">Australia</option>
										</select>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Customer Type</label>
									</div>
									<div class="col-sm-8">
										<select class="form-control" id="sel-update-customertype">
											<option value="Standard">Standard</option>
											<option value="Premium">Premium</option>
											<option value="Gold">Gold</option>
										</select>
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-4">
										<label for="input-create-discount">Register Status</label>
									</div>
									<div class="col-sm-8">
										<select class="form-control" id="sel-update-registerstatus">
											<option value="New">New</option>
											<option value="Denied">Denied</option>
											<option value="Accepted">Accepted</option>
										</select>
									</div>
								</div>
							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-success" id="btn-update-user">
								Update User
							</button>

							<button
								class="btn btn-secondary"
								id="btn-update-cancel"
								data-dismiss="modal"
							>
								Hủy bỏ
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-confirm-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">
								User Delete Confirmation
							</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa user này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-user">
								Confirm
							</button>
							<button class="btn btn-secondary" data-dismiss="modal">
								Cancel
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</body>
	<script>
		'use strict';
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
		var gUserId = 0;

		const gBASE_URL = 'http://203.171.20.210:8080/crud-api/users/';
		const gCONTENT_TYPE = 'application/json;charset=UTF-8';

		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gVOUCHER_COLS = [
			'id',
			'firstname',
			'lastname',
			'country',
			'subject',
			'customerType',
			'registerStatus',
			'action',
		];

		// Khai báo DataTable & mapping collumns
		var gUserTable = $('#user-table').DataTable({
			columns: [
				{ data: gVOUCHER_COLS[0] },
				{ data: gVOUCHER_COLS[1] },
				{ data: gVOUCHER_COLS[2] },
				{ data: gVOUCHER_COLS[3] },
				{ data: gVOUCHER_COLS[4] },
				{ data: gVOUCHER_COLS[5] },
				{ data: gVOUCHER_COLS[6] },
				{ data: gVOUCHER_COLS[7] },
			],
			columnDefs: [
				{
					// định nghĩa lại cột action
					targets: 7,
					className: 'd-flex',
					defaultContent: `
		      <button class = "btn btn-info edit-user" id="btn-sua">Sửa</button>
		      <button class = "btn btn-danger ml-3 delete-user" id="btn-xoa">Xóa</button>
		    `,
				},
			],
		});

		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$(document).ready(function () {
			// thực hiện tải trang
			onPageLoading();

			// 2 - C: gán sự kiện Create - Thêm mới user
			$('#btn-add-user').on('click', function () {
				onBtnAddNewUserClick();
			});

			$('#user-table').on('click', '.edit-user', function () {
				onBtnEditVoucherClick(this);
			});

			$('#user-table').on('click', '.delete-user', function () {
				onBtnDeleteVoucherClick(this);
			});

			// gán sự kiện cho nút Create user (trên modal)
			$('#btn-create-user').on('click', function () {
				onBtnCreateUserClick();
			});

			$('#btn-update-user').on('click', function () {
				onBtnUpdateUserClick();
			});

			$('#btn-confirm-delete-user').on('click', function () {
				onBtnDeleteUserClick();
			});
		});

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		// hàm thực thi khi trang được load
		function onPageLoading() {
			// 1 - R: Read / Load voucher to DataTable
			getAllUser();
		}

		function onBtnAddNewUserClick() {
			// hiển thị modal trắng lên
			$('#create-user-modal').modal('show');
		}

		function onBtnCreateUserClick() {
			// khai báo đối tượng chứa voucher data
			var vVoucherObj = {
				firstname: '',
				lastname: '',
				subject: '',
				country: '',
				customerType: '',
			};
			// B1: Thu thập dữ liệu
			getCreateUserData(vVoucherObj);
			// B2: Validate insert
			var vIsUserValidate = validateUserData(vVoucherObj);
			if (vIsUserValidate) {
				// B3: insert voucher
				$.ajax({
					url: gBASE_URL,
					type: 'POST',
					contentType: gCONTENT_TYPE,
					data: JSON.stringify(vVoucherObj),
					success: function (paramRes) {
						// B4: xử lý front-end
						handleInsertUserSuccess();
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					},
				});
			}
		}

		function onBtnEditVoucherClick(paramBtnEdit) {
			// lưu thông tin voucherId đang được edit vào biến toàn cục
			gUserId = getUserIdFromButton(paramBtnEdit);
			// load dữ liệu vào các trường dữ liệu trong modal
			getUserById(gUserId);
		}

		function onBtnDeleteVoucherClick(paramBtnEdit) {
			// lưu thông tin voucherId đang được edit vào biến toàn cục
			gUserId = getUserIdFromButton(paramBtnEdit);
			$('#delete-confirm-modal').modal('show');
		}

		function onBtnUpdateUserClick() {
			// khai báo đối tượng chứa voucher data
			var vVoucherObj = {
				firstname: '',
				lastname: '',
				subject: '',
				country: '',
				customerType: '',
				registerStatus: '',
			};
			// B1: Thu thập dữ liệu
			getUpdateUserData(vVoucherObj);
			// B2: Validate insert
			var vIsUserValidate = validateUserData(vVoucherObj);
			if (vIsUserValidate) {
				// B3: insert voucher
				$.ajax({
					url: gBASE_URL + gUserId,
					type: 'PUT',
					contentType: gCONTENT_TYPE,
					data: JSON.stringify(vVoucherObj),
					success: function (paramRes) {
						// B4: xử lý front-end
						handleUpdateUserSuccess();
					},
					error: function (paramErr) {
						console.log(paramErr.status);
					},
				});
			}
		}

		function onBtnDeleteUserClick() {
			// khai báo đối tượng chứa voucher data
			// B1: Thu thập dữ liệu
			// B2: Validate insert
			// B3: insert voucher
			$.ajax({
				url: gBASE_URL + gUserId,
				type: 'DELETE',
				contentType: gCONTENT_TYPE,
				success: function (paramRes) {
					// B4: xử lý front-end
					handleDeleteUserSuccess();
				},
				error: function (paramErr) {
					console.log(paramErr.status);
				},
			});
		}

		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		// hàm gọi api để lấy all danh sách user đăng ký
		function getAllUser() {
			$.ajax({
				url: gBASE_URL,
				type: 'GET',
				success: function (paramVouchers) {
					loadDataToUserTable(paramVouchers);
				},
				error: function (paramErr) {
					console.log(paramErr.status);
				},
			});
		}
		/** load voucher array to DataTable
		 * in: voucher array
		 * out: voucher table has data
		 */
		function loadDataToUserTable(paramVoucherArr) {
			gUserTable.clear();
			gUserTable.rows.add(paramVoucherArr);
			gUserTable.draw();
		}

		function getCreateUserData(paramUserObj) {
			paramUserObj.firstname = $('#input-create-firstname').val().trim();
			paramUserObj.lastname = $('#input-create-lastname').val().trim();
			paramUserObj.subject = $('#input-create-subject').val().trim();
			paramUserObj.country = $('#sel-country').val();
			paramUserObj.customerType = $('#sel-customertype').val();
		}

		function getUpdateUserData(paramUserObj) {
			paramUserObj.firstname = $('#input-update-firstname').val().trim();
			paramUserObj.lastname = $('#input-update-lastname').val().trim();
			paramUserObj.subject = $('#input-update-subject').val().trim();
			paramUserObj.country = $('#sel-update-country').val();
			paramUserObj.customerType = $('#sel-update-customertype').val();
			paramUserObj.registerStatus = $('#sel-update-registerstatus').val();
		}

		// hàm validate data
		function validateUserData(paramUserObj) {
			if (paramUserObj.firstname === '') {
				alert('firstname cần nhập');
				return false;
			}
			if (paramUserObj.lastname === '') {
				alert('lastname cần nhập');
				return false;
			}
			if (paramUserObj.subject === '') {
				alert('subject cần nhập');
				return false;
			}
			if (paramUserObj.country === '') {
				alert('country cần chọn');
				return false;
			}
			if (paramUserObj.customerType === '') {
				alert('customerType cần chọn');
				return false;
			}

			if (paramUserObj.registerStatus === '') {
				alert('customerType cần chọn');
				return false;
			}

			return true;
		}

		// hàm xử lý hiển thị front-end khi thêm voucher thành công
		function handleInsertUserSuccess() {
			alert('Thêm user thành công!');
			getAllUser();
			resertCreateUserForm();
			$('#create-user-modal').modal('hide');
		}

		function resertCreateUserForm() {
			$('#input-create-firstname').val('');
			$('#input-create-lastname').val('');
			$('#input-create-subject').val('');
			$('#sel-country').val('');
			$('#sel-customertype').val('');
		}

		// hàm get voucher by id
		function getUserById(paramVoucherId) {
			$.ajax({
				url: gBASE_URL + paramVoucherId,
				type: 'GET',

				success: function (paramVoucher) {
					showUserDataToModal(paramVoucher);
				},
				error: function (paramErr) {
					console.log(paramErr.status);
				},
			});
			// hiển thị modal lên
			$('#update-user-modal').modal('show');
		}

		function showUserDataToModal(paramVoucher) {
			$('#input-update-firstname').val(paramVoucher.firstname);
			$('#input-update-lastname').val(paramVoucher.lastname);
			$('#input-update-subject').val(paramVoucher.subject);
			$('#sel-update-country').val(paramVoucher.country);
			$('#sel-update-customertype').val(paramVoucher.customerType);
			$('#sel-update-registerstatus').val(paramVoucher.registerStatus);
		}

		// hàm xử lý hiển thị front-end khi sửa user thành công
		function handleUpdateUserSuccess() {
			alert('Sửa user thành công!');
			getAllUser();
			resertUpdateUserForm();
			$('#update-user-modal').modal('hide');
		}

		// hàm xử lý hiển thị front-end khi sửa user thành công
		function handleDeleteUserSuccess() {
			alert('xóa user thành công!');
			getAllUser();
			$('#delete-confirm-modal').modal('hide');
		}

		function resertUpdateUserForm() {
			$('#input-update-firstname').val('');
			$('#input-update-lastname').val('');
			$('#input-update-subject').val('');
			$('#sel-update-country').val('');
			$('#sel-update-customertype').val('');
			$('#sel-update-registerstatus').val('');
		}

		function getUserIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents('tr');
			var vUserRowData = gUserTable.row(vTableRow).data();
			return vUserRowData.id;
		}
	</script>
</html>
